package examples;

import fpcs.utils.ImageUtils;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 *
 * @author Ignas Kukenys
 *
 */

public class ClassifierPainter {

    public static void main(String[] args) {
        try {
            
            String file = "d:/tebadi/fpcsRotate/FPCS-UCS-CM/classifierExample.txt";
            String output = "d:/tebadi/fpcsRotate/FPCS-UCS-CM/";
            Scanner lines = new Scanner(new File(file));

           Pattern pattern = Pattern.compile("(HAAR.+?): (\\d+?),(\\d+?)-(\\d+?)x(\\d+?) in \\(\\s*([-+]?[0-9]*\\.?[0-9]+),\\s*([-+]?[0-9]*\\.?[0-9]+)\\)");

            int c = 0;
            while(lines.hasNextLine()) {

                String line = lines.nextLine();
                if (!line.isEmpty()) {

                    String digit = "" + line.charAt(line.length() - 1);

                    Matcher matcher = pattern.matcher(line);

                    int w = 28;
                    int h = 28;
                    int scale = 10;

                    BufferedImage im = new BufferedImage(w * scale, h * scale, BufferedImage.TYPE_BYTE_GRAY);

                    Graphics2D g = im.createGraphics();
                    g.setColor(new Color(127, 127, 127));
                    g.fillRect(0, 0, w * scale, h * scale);


                    while(matcher.find()) {

                        paintFeature(g, matcher.group(1), matcher.group(2), matcher.group(3), matcher.group(4), matcher.group(5), scale);

                        for (int i = 1; i < matcher.groupCount(); i++) {
                            System.out.print(matcher.group(i));
                        }
                        System.out.println("");
                    }
                    g.dispose();

//                    String filename = String.format("%03d-%s.png", c, digit);
                    String filename="test"+c+".jpg";
                    System.out.println(output + "/" + filename);
                    ImageUtils.saveImage(im, output + "/" + filename);
                    

                }

                c++;
            }

        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        }
    }

    private static void paintFeature(Graphics2D g, String type, String xs, String ys, String ws, String hs, int scale) {

        int x = Integer.parseInt(xs);
        int y = Integer.parseInt(ys);
        int w = Integer.parseInt(ws);
        int h = Integer.parseInt(hs);

        Color blackish = new Color(0, 0, 0, 192);
        Color whiteish = new Color(255, 255, 255, 192);

        int ty=0;


if(type.equals("HAAR1"))
    ty=1;
else if(type.equals("HAAR2HOR"))
    ty=2;
else if(type.equals("HAAR2VER"))
    ty=3;
else if(type.equals("HAAR3HOR"))
    ty=4;
else if(type.equals("HAAR3VER"))
    ty=5;
else if(type.equals("HAAR4"))
    ty=6;



        switch(ty) {

            case 1:
                g.setColor(blackish);
                g.fillRect(x * scale, y * scale, w * scale, h * scale);

                break;
            
            case 2:
                g.setColor(blackish);
                g.fillRect(x * scale, y * scale, w * scale, h * scale);
                
                g.setColor(whiteish);
                g.fillRect(x * scale, y * scale, w / 2 * scale, h * scale);
                break;


            case 3:
                g.setColor(blackish);
                g.fillRect(x * scale, y * scale, w * scale, h * scale);

                g.setColor(whiteish);
                g.fillRect(x * scale, y * scale, w * scale, h / 2 * scale);
                break;

            case 4:
                g.setColor(whiteish);
                g.fillRect(x * scale, y * scale, w * scale, h * scale);

                g.setColor(blackish);
                g.fillRect((x + w / 3)  * scale, y * scale, w / 3 * scale, h * scale);
                break;

            case 5:
                g.setColor(whiteish);
                g.fillRect(x * scale, y * scale, w * scale, h * scale);

                g.setColor(blackish);
                g.fillRect(x * scale, (y + h / 3) * scale, w * scale, h / 3 * scale);
                break;

            case 6:
                g.setColor(blackish);
                g.fillRect(x * scale, y * scale, w * scale, h * scale);

                g.setColor(whiteish);
                g.fillRect(x * scale, y * scale, w / 2 * scale, h / 2 * scale);
                g.fillRect((x + w / 2) * scale, (y + h / 2) * scale, w / 2 * scale, h / 2 * scale);

                break;


            
        }

    }


}
