package fpcs.image;

import fpcs.core.ClassifierFactory;
import fpcs.core.State;

/**
 *
 * @author Ignas Kukenys
 *
 */
public class ImageClassifierFactory extends ClassifierFactory {

    private static final ImageClassifierFactory singleton = new ImageClassifierFactory();

    private ImageClassifierFactory() {}

    public static ImageClassifierFactory getInstance() {
        return singleton;
    }

    @Override
    public ImageClassifier createForStateAndAction(State state, int action, double setSize, int timestamp) {
        return new ImageClassifier(state, action, setSize, timestamp);
    }

}
