package fpcs.image;

import fpcs.core.State;

/**
 *
 * @author Ignas Kukenys
 *
 */
public class ImageState extends State {

    public final int width;
    public final int height;
    public final double[] data;
    private final double[] integralData;

    public ImageState(int width, int height, double[] data) {
        this.width = width;
        this.height = height;
        this.data = data;

        double[] rowsum = new double[data.length];
        integralData = new double[data.length];
        for(int i = 0; i < data.length; i++) {
            rowsum[i] = (i % width == 0)?data[i]:rowsum[i-1] + data[i];
            integralData[i] = (i < width)?rowsum[i]:integralData[i - width] + rowsum[i];
        }

    }

    public double integral(int x, int y) {
        if (x < 0 || y < 0) {
            return 0;
        } else {
            return integralData[y * width + x];
        }
    }

    @Override
    public String toString() {
        String result = "";

        for(int i = 0; i < data.length; i++) {
            result += data[i]>127?"1":"0";
        }

        return result;
    }

}
