package fpcs.symbolic;

import fpcs.core.ClassifierFactory;
import fpcs.core.State;

/**
 *
 * @author Ignas Kukenys
 *
 */
public class SymbolicClassifierFactory extends ClassifierFactory{

    private static final SymbolicClassifierFactory singleton = new SymbolicClassifierFactory();

    private SymbolicClassifierFactory() {}

    public static SymbolicClassifierFactory getInstance() {
        return singleton;
    }

    @Override
    public SymbolicClassifier createForStateAndAction(State state, int action, double setSize, int timestamp) {
        return new SymbolicClassifier(state, action, setSize, timestamp);
    }

}
