package fpcs.symbolic.patterns;

import fpcs.core.Environment;
import fpcs.core.ClassifierFactory;
import fpcs.core.RandomUtils;
import fpcs.core.State;
import fpcs.symbolic.SymbolicClassifierFactory;
import fpcs.symbolic.SymbolicState;

/**
 *
 * @author Ignas Kukenys
 *
 */

public class MNISTSymbolicPatternEnvironment extends Environment {

    private SymbolicPatternProvider patterns;
    private char[] currentPattern;

    public MNISTSymbolicPatternEnvironment(SymbolicPatternProvider patterns) {
        this.patterns = patterns;
        currentPattern = new char[patterns.getPatternSize()];
    }

    @Override
    public State resetState() {
        int dice = (int)(patterns.size() * RandomUtils.random());
        currentPattern = patterns.getPattern(dice, currentPattern);
        currentState = new SymbolicState(currentPattern);
        currentClass = patterns.getClassLabel(dice);

        return currentState;
    }

    @Override
    public int getNumActions() {
        return 10;
    }

    public ClassifierFactory getClassifierFactory() {
        return SymbolicClassifierFactory.getInstance();
    }


}
