package fpcs.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 *
 * @author Ignas Kukenys
 * 
 */

public class IDXFileReader {

    public static final int IDX_SIZE_HEADER = 4;
    public static final int IDX_SIZE_DIMENSION = 4;

    public static byte[] readAllBytes(String filename, int dimensions) {
        

        try {
            FileInputStream fis = new FileInputStream(filename);
            
            int len = (int)(new File(filename)).length();
            fis.skip(IDX_SIZE_HEADER); // header
            fis.skip(IDX_SIZE_DIMENSION * dimensions); // dimensions

            byte[] bytes = new byte[len - IDX_SIZE_DIMENSION * (dimensions) - IDX_SIZE_HEADER];
            len = fis.read(bytes, 0, bytes.length);

            fis.close();

            return bytes;
        }
        catch (FileNotFoundException ex) {
            throw new RuntimeException("File not found: " + filename, ex);
        }
        catch (IOException ex) {
            throw new RuntimeException("Error reading: " + filename, ex);
        }


    }

}
