package problems.mnist;

import fpcs.core.Environment;
import fpcs.core.RandomUtils;
import fpcs.core.State;

/**
 *
 * @author Ignas Kukenys
 *
 */

public class MNISTImagePatternEnvironment extends Environment {

    private MNISTImagePatternProvider patterns;

    public MNISTImagePatternEnvironment(MNISTImagePatternProvider patterns) {
        this.patterns = patterns;
    }

    @Override
    public State resetState() {
        int dice = (int)(patterns.size() * RandomUtils.random());
    
        currentState = patterns.getPattern(dice);
        currentClass = patterns.getLabel(dice);

        return currentState;
    }

    @Override
    public int getNumActions() {
        return patterns.getNumActions();
    }

}
