package fpcs.listeners;

import fpcs.core.ClassifierSet;
import fpcs.core.ITrainingListener;
import fpcs.core.State;
import fpcs.utils.BagOfValues;

/**
 *
 * @author Ignas Kukenys
 *
 */
public class IExploitListener implements ITrainingListener{

    private int resultWindowSize = 50;
    private int printFreequency = 50;

    private boolean[] correct;
    private double[] systemError;

    private int counter = 0;

    public IExploitListener() {
         correct = new boolean[resultWindowSize];
        systemError = new double[resultWindowSize];
    }

    public IExploitListener(int resultWindowSize, int printFreequency) {
        this.resultWindowSize = resultWindowSize;
        correct = new boolean[resultWindowSize];
        systemError = new double[resultWindowSize];
        this.printFreequency = printFreequency;
    }


//    public void onExploit(BagOfValues info) {
  public void onExploit(int generation, State state, int stateAction, ClassifierSet population, ClassifierSet matchSet, int actionTaken, double prediction, double reward, boolean wasCorrect){
//        if(info.getInt("selectedAction")==info.get("actualAction"))
//            noTrue++;
//        else{
//            noFalse++;
//            System.out.println("selected: "+info.getString("selectedAction")+" Actual: "+info.get("actualAction"));
//        }
//        System.out.println(info.getInt("selectedAction")==info.get("actualAction"));
        correct[counter % resultWindowSize] = wasCorrect;
        systemError[counter % resultWindowSize] = Math.abs(prediction - reward);

        if (counter % printFreequency == 0 && counter > 0) {
            printStats(generation,population.size());
        }

        counter++;
    }

    protected void printStats(int generation,int macroPopulation) {

        double perf = 0.0;
        double serr = 0.0;

        for (int i = 0; i < correct.length; i++) {
            perf += correct[i]?1:0;
            serr += systemError[i];
        }
        perf /= resultWindowSize;
        serr /= resultWindowSize;


        System.out.println(String.format("G: %d Perf: %.3f Err: %.3f P: %d ",
                generation,
                perf,
                serr,
                macroPopulation
        ));
    }

  

}
